<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org"
      xmlns="http://www.w3.org/1999/xhtml">

<head>
    <meta charset="utf-8"/>
    <title>User Registration</title>

    <!-- Bootstrap core CSS -->
    <link
            href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"
            rel="stylesheet"
            integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u"
            crossorigin="anonymous"/>

    <link th:href="@{css/style.css}" rel="stylesheet"/>
    <link th:href="@{css/fv.css}" rel="stylesheet"/>

    <!--    <style>-->
    <!--        meter {-->
    <!--            /* Reset the default appearance */-->
    <!--            -webkit-appearance: none;-->
    <!--            -moz-appearance: none;-->
    <!--            appearance: none;-->

    <!--            margin: 0 auto 1em;-->
    <!--            width: 100%;-->
    <!--            height: 0.5em;-->

    <!--            /* Applicable only to Firefox */-->
    <!--            background: none;-->
    <!--            background-color: rgba(0, 0, 0, 0.1);-->
    <!--        }-->

    <!--        meter::-webkit-meter-bar {-->
    <!--            background: none;-->
    <!--            background-color: rgba(0, 0, 0, 0.1);-->
    <!--        }-->

    <!--        /* Webkit based browsers */-->
    <!--        meter[value="1"]::-webkit-meter-optimum-value {-->
    <!--            background: red;-->
    <!--        }-->

    <!--        meter[value="2"]::-webkit-meter-optimum-value {-->
    <!--            background: yellow;-->
    <!--        }-->

    <!--        meter[value="3"]::-webkit-meter-optimum-value {-->
    <!--            background: orange;-->
    <!--        }-->

    <!--        meter[value="4"]::-webkit-meter-optimum-value {-->
    <!--            background: green;-->
    <!--        }-->

    <!--        /* Gecko based browsers */-->
    <!--        meter[value="1"]::-moz-meter-bar {-->
    <!--            background: red;-->
    <!--        }-->

    <!--        meter[value="2"]::-moz-meter-bar {-->
    <!--            background: yellow;-->
    <!--        }-->

    <!--        meter[value="3"]::-moz-meter-bar {-->
    <!--            background: orange;-->
    <!--        }-->

    <!--        meter[value="4"]::-moz-meter-bar {-->
    <!--            background: green;-->
    <!--        }-->
    <!--    </style>-->
</head>

<body class="gray-bg">

<div class="middle-box text-center loginscreen animated fadeInDown" id="registraTioForm">
    <div>

        <hr/>
        <h4>Set Your Password</h4>

        <div th:if="${successMessage}" class="alert alert-success"
             role="alert" th:text=${successMessage}></div>

        <div th:if="${errorMessage}" class="alert alert-danger"
             role="alert" th:text=${errorMessage}></div>

        <div th:if="${error}" class="alert alert-danger"
             role="alert" th:text=${error}></div>

        <div th:if="${invalidToken}" class="alert alert-danger"
             role="alert" th:text=${invalidToken}></div>
        <div th:if="!${error}">

            <form th:if="!${invalidToken}" class="m-t" id="passwordForm" role="form" action="#"
                  th:object="${setPassword}" th:action="@{/confirm}" method="post">

                <input type="hidden" name="token" th:value="${confirmationToken} ">

                <h5> Please consider setting up a strong password and follow the meter below</h5>

                <div class="form-group input-group">
          <span class="input-group-addon">
            <span class="glyphicon glyphicon-lock"></span>
          </span>
                    <input name="password" type="password" id="password"
                           placeholder="Password" class="form-control" required/>
                    <span class="glyphicon"
                          aria-hidden="true"></span>
                </div>

                <meter max="4" id="password-strength-meter"></meter>
                <p id="password-strength-text"></p>

                <!--            <div class="form-group input-group has-feedback">-->
                <!--          <span class="input-group-addon">-->
                <!--            <span class="glyphicon glyphicon-lock"></span>-->
                <!--          </span>-->
                <!--                <input type="password" class="form-control" id="signup-password-confirm" placeholder="Confirm Password" name="ConfirmPassword" data-fv-notempty="true" required-->
                <!--                       data-fv-notempty-message="Please confirm password"-->
                <!--                       data-fv-identical="true"-->
                <!--                       data-fv-identical-field="password"-->
                <!--                       data-fv-identical-message="Both passwords must be identical" />-->

                <!--                <div class="help-block with-errors"></div>-->
                <!--            </div>-->


                <button type="submit"
                        class="btn btn-primary block full-width m-b" id="setPasswordButton">Save
                </button>

            </form>
        </div>

    </div>
</div>


<!-- jQuery-->
<script
        src="//ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>

<!-- Bootstrap -->
<script
        src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"
        integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
        crossorigin="anonymous"></script>


<script src="//cdnjs.cloudflare.com/ajax/libs/zxcvbn/4.4.2/zxcvbn.js"></script>

<script th:src="@{js/fv.min.js}"></script>
<script>
    $(document).ready(function () {
        $('#passwordForm').formValidation({
            framework: 'bootstrap',
            icon: {
                valid: 'glyphicon glyphicon-ok',
                invalid: 'glyphicon glyphicon-remove',
                validating: 'glyphicon glyphicon-refresh'
            },
            fields: {

                password: {
                    validators: {
                        notEmpty: {
                            message: 'The password is required'
                        },
                        callback: {
                            callback: function (value, validator, $field) {
                                var password = $field.val();
                                if (password == '') {
                                    return true;
                                }

                                var result = zxcvbn(password),
                                    score = result.score,
                                    message = result.feedback.warning || 'The password is weak';

                                // Update the progress bar width and add alert class
                                var $bar = $('#strengthBar');
                                switch (score) {
                                    case 0:
                                        $bar.attr('class', 'progress-bar progress-bar-danger')
                                            .css('width', '1%');
                                        break;
                                    case 1:
                                        $bar.attr('class', 'progress-bar progress-bar-danger')
                                            .css('width', '25%');
                                        break;
                                    case 2:
                                        $bar.attr('class', 'progress-bar progress-bar-danger')
                                            .css('width', '50%');
                                        break;
                                    case 3:
                                        $bar.attr('class', 'progress-bar progress-bar-warning')
                                            .css('width', '75%');
                                        break;
                                    case 4:
                                        $bar.attr('class', 'progress-bar progress-bar-success')
                                            .css('width', '100%');
                                        break;
                                }

                                // We will treat the password as an invalid one if the score is less than 3
                                if (score < 3) {
                                    return {
                                        valid: false,
                                        message: message
                                    }
                                }

                                return true;
                            }
                        }
                    }
                }
                // confirmPassword: {
                //     validators: {
                //         identical: {
                //             compare: function() {
                //                 return form.querySelector('[name="password"]').value;
                //             },
                //             message: 'The password and its confirm are not the same'
                //         }
                //     }
                // }
            }
        });
        // form.querySelector('[name="password"]').addEventListener('input', function() {
        //     fv.revalidateField('confirmPassword');
        // });
    });
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/zxcvbn/4.2.0/zxcvbn.js"></script>
<script>
    "use strict";
    var strength = {
        0: "Worst",
        1: "Bad",
        2: "Weak",
        3: "Good",
        4: "Strong"
    }

    var password = document.getElementById('password');
    var meter = document.getElementById('password-strength-meter');
    var text = document.getElementById('password-strength-text');

    password.addEventListener('input', function () {
        var val = password.value;
        var result = zxcvbn(val);

        // Update the password strength meter
        meter.value = result.score;

        // Update the text indicator
        if (val !== "") {
            text.innerHTML = "Strength: " + strength[result.score];
        } else {
            text.innerHTML = "";
        }
    });
</script>
</body>

</html>
